
#ifndef ORDER_H
#define ORDER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "set.h"

struct binaryOrder_s
{
	int classBefore;
	int classAfter;
	
	int isMarkBefore;
	int isMarkAfter;
};

typedef struct binaryOrder_s binaryOrder;

struct ordering_s
{
	int noOfBinaryOrder;
	binaryOrder *orderList;
};

typedef struct ordering_s ordering;

struct mainOrdering_s
{
	int noOfElt;
	ordering **elt;
};

typedef struct mainOrdering_s mainOrdering;

ordering *ordering_new();
ordering *ordering_clone(ordering *anOrdering);
void ordering_free(ordering *anOrdering);

void ordering_insertBinaryOrder2Ordering(ordering *anOrdering, int classBefore, int classAfter);
void ordering_printOrdering(FILE *filePtr, ordering *anOrdering);
mySetSet *ordering_generateAllLinearOrdering(ordering *anOrdering);

mainOrdering *mainOrdering_new();

int ordering_isContain(ordering *anOrdering, int classID, int classID2);

void mainOrdering_insert(mainOrdering *aMainOrdering, ordering **anOrdering);

int mainOrdering_isContain_disqualify(int noOfNumAttr, mainOrdering *aMainOrdering, myClassSet *aClassSet);

mainOrdering *mainOrdering_transformOrderSet2MainOrdering(myOrderSet *anOrderSet);
void mainOrdering_printMainOrdering(FILE *filePtr, mainOrdering *aMainOrdering);
mainOrdering* mainOrdering_transformPartialOrder2MainOrdering(int *noOfClass, mySetSet *R);
void mainOrdering_free(mainOrdering *aMainOrdering);

#endif
