#include "preferenceTree.h"
#define EMPTY_NODE -1
#define METHOD 0


int preferenceTree_noOfNode = 0;
int callCount = 0;

typedef struct intPair_s
{
	int pointID;
	int index;
}intPair;

int intPairCompare(const void *p1, const void *p2)
{
	int a = ((intPair *)p1)->pointID;
	int b = ((intPair *)p2)->pointID;
	if(a>b)
		return 1;
	else if(a==b)
		return 0;
	else 
		return -1;
}
/**
 * It create a preference tree.
 * param aConfig Config structure
 * param mdc MDC table
 * return root node for preference tree
 * @author Terry & Sing
 * @since 19 March2007
 */
preferenceTreeNode* buildPreferenceTree(config *aConfig, myClassSetSetSet* mdc)
{
	preferenceTreeNode *root;
	int *p;
	myClassSet *disqCondition;

	int i, j, k;
	int noOfNum;
	mySet *S;
	myClassSet *w;

	mySet *validIndex;

	int c, d;

	//New Method
	if(METHOD==1)
	{

	//int a;
	
	noOfNum	= (aConfig->noOfDim - aConfig->noOfCat) ;

	//build the tree structure
	root = buildPreferenceTreeDescend(aConfig, -1, 0);

	//fill in the tree
	p = (int *)malloc(sizeof(int)*aConfig->noOfCat);
	/*
	//sort the points first
	intPair **ip;
	ip = (intPair **)malloc(sizeof(intPair *)*mdc->noOfElt);
	for (i=0;i<mdc->noOfElt;i++)
	{	
		ip[i] = (intPair *)malloc(sizeof(intPair));
		ip[i]->pointID = mdc->pointID[i];
		ip[i]->index = i;
	}
	qsort((void *)ip, mdc->noOfElt, sizeof(intPair *), intPairCompare);
	*/

	
	//foreach points
	//for (a=0;a<mdc->noOfElt;a++)
	for (i=0;i<mdc->noOfElt;i++)
	{
		//i = ip[a]->index;
		//debug
		list_add(root->disqualifiedPoint, mdc->pointID[i]);
		//foreach disqualify condition
		for(j=0;j<mdc->elt[i]->noOfElt;j++)
		{
			for(k=0;k<aConfig->noOfCat;k++)
			{
				p[k]=-1;
			}
			disqCondition= mdc->elt[i]->elt[j];
			for(k=0;k<disqCondition->noOfElt; k++)
			{
				d = (disqCondition->dimNo[k])-noOfNum;
				c = disqCondition->list[k]->elt[0];
				p[d] = c;
			}
			fillPreferenceTreeDescend(root, 0, mdc->pointID[i], p);
		}
	}

	}
	else
	{



	w = classSet_new();

	//Find global skyline to put in root node, all points in MDC table
	//are skyline points.
	S = set_new();
	for (i=0;i<mdc->noOfElt;i++)
	{
		set_insert(S, mdc->pointID[i]);
	}

	// validIndex
	validIndex = set_new();
	validIndex->noOfElt = mdc->noOfElt;
	validIndex->elt = (int *) malloc(sizeof(int)*validIndex->noOfElt);
	for (i = 0; i < validIndex->noOfElt; i++)
	{
		validIndex->elt[i] = i;
	}

	//Start recursive descend
	root = buildPreferenceTreeDescendOld(aConfig, mdc, validIndex, -1, 0, NULL, S, w);

	//Free memory
	set_free(validIndex);
	free(validIndex);
	set_free(S);
	free(S);
	classSet_free(w);
	free(w);

	//printf("%d \n", root);
	//return root

	}
	return root;
}

// return: nonDisqualifyIndex (w.r.t mdc)
mySet *preference_findDisqualifyIndexAndNonDisqualifyIndex(myClassSetSetSet *mdc, mySet *validIndexSet, myClassSet *newP, mySet *disqualifyEltSet)
{
	mySet *nonDisqualifyIndexSet;
	int i, j, k, l;

	int isDisqualify;
	int isFullFill;

	myClassSet *disqCondition;

	int aIndex;

	nonDisqualifyIndexSet = set_new();

		//*** Ray modified
		//For each point
		//for (i=0; i<Skyline->noOfElt; i++)
		//{
		for (i = 0; i < validIndexSet->noOfElt; i++)
		{
			aIndex = validIndexSet->elt[i];
			j = aIndex;
			//for (j=0; j<mdc->noOfElt; j++)
			//{
				//Find the corresponding mdc
				//if (mdc->pointID[j] == Skyline->elt[i])
				//{
					isDisqualify = 0; //1: point is should be disqualified
					//For each disqualify condition
					for (k=0 ; k<mdc->elt[j]->noOfElt ; k++)
					{
						disqCondition= mdc->elt[j]->elt[k];

						isFullFill = 1;	//1: fullfill this disCondition
						//For each binary ordering
						for (l=0; l<disqCondition->noOfElt; l++)
						{
//								printf("PointID: %d\n", i);
//								printf("*****\n");
//								puts("Preference");
//								classSet_print(stdout, newP);
//								puts("MDC");
//								classSet_print(stdout, disqCondition);
//								printf("*****\n");

							//Check if the disqualifying element in this binary ordering
							//can be found in the accumulative preferences
							if (!classSet_isContain(newP, disqCondition->dimNo[l], disqCondition->list[l]->elt[0]))
							{
								isFullFill = 0;
								break;
							}
						}
						//State that the current examined point should be disqualified
						//if disqualifying condition is fullfill
						if (isFullFill==1)
						{
							isDisqualify=1;
							break;
						}

					}
					if (isDisqualify==1)
					{
						//Insert current examined point to the set of
						//disqualified points of current node
						//list_add(node->disqualifiedPoint, Skyline->elt[i]);
						
						
						//list_add(node->disqualifiedPoint, mdc->pointID[j]);
						//set_insert(disqualifyEltSet, mdc->pointID[j]);
						setSort_insertSort(disqualifyEltSet, mdc->pointID[j]);
					}
					else
					{
						set_insert(nonDisqualifyIndexSet, j);
					}
				//}
			//}
		//}
		}

	return nonDisqualifyIndexSet;
}

/**
 * It create a node in preference tree and continue to recursive descend
 * to build its child nodes
 * param aConfig Config structure
 * param mdc MDC table
 * param dimLevel The dimension/level of the current descend
 *                (-1 for root level, 1 for child of root etc)
 * param classBefore Dominating element in the partial order of current
 *                   node. ("A" < others)
 * param parent Parent node of the new node created in current descend
 * param skyline Set of skyline points that survive with all partial orders
 *               of its ancestor endorced
 * param accumulativePreference Represent accumulative partial orders from
 *                              ancestors
 * return root node for preference tree
 * @author Terry & Sing
 * @since 27 Feb 2007
 */
preferenceTreeNode* buildPreferenceTreeDescendOld(config *aConfig, myClassSetSetSet* mdc, mySet *validIndexSet, int dimLevel, int classBefore, preferenceTreeNode *parent, mySet *Skyline, myClassSet *accumulativePreference)
{
	int noOfNum;
	int noOfClass;
	int i;
	preferenceTreeNode *node;
	myClassSet *newP;

	preferenceTreeNode *child;

	mySet *nonDisqualifyIndexSet;

	preferenceTree_noOfNode++;
	noOfNum	= (aConfig->noOfDim - aConfig->noOfCat) ;

	//Make a new node
	node = preferenceTreeNode_new(dimLevel, classBefore);

	
	newP = classSet_new();

	//Process the root node
	if (dimLevel==-1)
	{
		//Initialize the root
		//The root node store the set of skyline points rather than
		//set of disqualified points
		for (i=0;i<Skyline->noOfElt;i++)
		{
			//list_add(node->disqualifiedPoint, Skyline->elt[i]);
			setSort_insertSort(node->setDisqualifiedPoint, Skyline->elt[i]);
		}

		//update the dimemsion number
		//dimLevel = (noOfNum) -1;
	}
	else
	{
		//Make a new copy of accumulative preferences for recursive desend
		//even if it is a empty node
		classSet_copy(newP, accumulativePreference);

		//Find out the disqualified points in Skyline with respect to
		//accumulative preference
		if (classBefore != EMPTY_NODE)
		{
			//Update the accumulative preference
			classSet_insert(newP, dimLevel+noOfNum, classBefore);
		}
	}
	
//	puts("Skyline");
//	set_print(stdout, newS);

	//add disqualified points
	nonDisqualifyIndexSet = preference_findDisqualifyIndexAndNonDisqualifyIndex(mdc, validIndexSet, newP, node->setDisqualifiedPoint);
	//nonDisqualifyIndexSet = validIndexSet;

	
	//Continue recursive descend if current dimension is not
	//the last dimension
	if (dimLevel < aConfig->noOfCat-1)
	{
		//Create child nodes, including empty node
		if (aConfig->isCompress == 1)
		{
			noOfClass = aConfig->compress_noOfClass;
		}
		else
		{
			noOfClass = aConfig->noOfClass[dimLevel+1];
		}
		node->child=(preferenceTreeNode **)malloc(sizeof(preferenceTreeNode*)*(noOfClass+1));
		for (i=-1;i<noOfClass;i++)
		{
			child = buildPreferenceTreeDescendOld(aConfig, mdc, nonDisqualifyIndexSet, dimLevel+1, i, node, Skyline, newP);
			node->child[i+1] = child;
		}
		node->noOfChild = noOfClass + 1;

		// free nonDisqualifyIndexSet
		//set_free(nonDisqualifyIndexSet);
		//free(nonDisqualifyIndexSet);
	}
	else
	{
		// free nonDisqualifyIndexSet
		//set_free(nonDisqualifyIndexSet);
		//free(nonDisqualifyIndexSet);

		// do nothing
		// 
		//nonDisqualifyIndexSet = preference_findDisqualifyIndexAndNonDisqualifyIndex(mdc, validIndexSet, newP, node->setDisqualifiedPoint);
		//nonDisqualifyIndexSet = preference_findDisqualifyIndexAndNonDisqualifyIndex(mdc, nonDisqualifyIndexSet, newP, node->setDisqualifiedPoint);

		// free nonDisqualifyIndexSet
		//set_free(nonDisqualifyIndexSet);
		//free(nonDisqualifyIndexSet);
	}

	// free nonDisqualifyIndexSet
	//set_free(nonDisqualifyIndexSet);
	//free(nonDisqualifyIndexSet);

	//Free memory
	classSet_free(newP);
	free(newP);
	
	return node;
}



/**
 * It create a node in preference tree and continue to recursive descend
 * to build its child nodes
 * param aConfig Config structure
 * param dimLevel The dimension/level of the current descend
 *                (-1 for root level, 1 for child of root etc)
 * param classBefore Dominating element in the partial order of current
 *                   node. ("A" < others)
 * return node for preference tree
 * @author Terry
 * @since 19 March 2007
 */
preferenceTreeNode* buildPreferenceTreeDescend(config *aConfig, int dimLevel, int classBefore)
{
	preferenceTreeNode *node;
	int i;

	preferenceTree_noOfNode++;

	
	//int noOfNum	= (aConfig->noOfDim - aConfig->noOfCat) ;

	//Make a new node
	node = preferenceTreeNode_new(dimLevel, classBefore);

	//Process the root node
	if (dimLevel==-1)
	{
		//update the dimemsion number
		//dimLevel = (noOfNum) -1;
	}
	

	//Continue recursive descend if current dimension is not
	//the last dimension
	if (dimLevel < aConfig->noOfCat-1)
	{
		preferenceTreeNode *child;
		//Create child nodes, including empty node
		int noOfClass = aConfig->noOfClass[dimLevel+1];
		node->child=(preferenceTreeNode **)malloc(sizeof(preferenceTreeNode*)*(noOfClass+1));
		for (i=-1;i<noOfClass;i++)
		{
			child = buildPreferenceTreeDescend(aConfig, dimLevel+1, i);
			//index of child is 1 right shift of the values of class
			node->child[i+1] = child;
		}
		node->noOfChild = noOfClass + 1;
	}
	return node;
}

/**
 * Fill the tree with disqualify data point
 * @param node
 * @param dimNo
 * @param pointID
 * @param p
 * @author Terry
 * @since 19 March 2007
 */
void fillPreferenceTreeDescend(preferenceTreeNode *node, int dimLevel, int pointID, int *p)
{
//	callCount++;
	if(node->noOfChild==0)
	{
		//reach the leave
		//add the point into the disqualified point set
		list_add(node->disqualifiedPoint, pointID);
	}
	else
	{
		//inter-node
		if(p[dimLevel]==-1)
		{
			int i;
			for(i=0;i<node->noOfChild;i++)
			{
				fillPreferenceTreeDescend(node->child[i], dimLevel+1, pointID, p);
			}
		}
		else
		{
			fillPreferenceTreeDescend(node->child[p[dimLevel]+1], dimLevel+1, pointID, p);
		}
	}
}


/**
 * Allocate and set zero the memory of a new preferenceTreeNode.
 * It will also assign the parent node and the refinement
 * correspond to this node. It will also create new mySet
 * to store the disqualified pointID
 * @param dimNo
 * @param classBefore
 * @return Pointer to the new mdcTreeNode struct
 * @author Terry & Sing
 * @since 27 Feb 2007
 */
preferenceTreeNode* preferenceTreeNode_new(int dimNo, int classBefore)
{
	preferenceTreeNode* node;
	node = (preferenceTreeNode*) malloc(sizeof(preferenceTreeNode));
	node->noOfChild = 0;
	node->child = NULL;
	node->dimNo = dimNo;
	node->classBefore = classBefore;
	node->disqualifiedPoint = list_new();
	node->setDisqualifiedPoint = set_new();
	return node;
}

/**
 * It pint recurisvely the preference tree in dotty format
 * @param filePtr
 * @param node The root node
 * @param id The id of root node(0)
 * @author Terry & Sing
 * @since 27 Feb 2007
 */
void printPreferenceTree(FILE *filePtr, preferenceTreeNode *node, int *id)
{
	int selfId;
	int i=0;

	(*id)++;
	selfId = *id;
	fprintf(filePtr, "%d [shape=box,label=\"", *id);
	printPreferenceTreeNode(filePtr, node);
	fputs("\"];\n", filePtr);
	for (i=0; i< node->noOfChild; i++)
	{
		fprintf(filePtr, "%d -> %d;\n", selfId, *id+1);
		printPreferenceTree(filePtr, node->child[i], id);
	}
}

/**
 * It print the refinement and disqualified point of a node
 * @param filePtr file to print to 
 * @param node The node you want to print
 * @author Terry & Sing
 * @since 27 Feb 2007
 */
void printPreferenceTreeNode(FILE *filePtr, preferenceTreeNode *node)
{
	//int i=0;
	if (node->dimNo==-1)
	{
		fprintf(filePtr, "root:");
	}
	else
	{
		fprintf(filePtr, "(%d, %d<*):\\r", node->dimNo,
				node->classBefore);
	}
	fputs("{", filePtr);
	list_print(node->disqualifiedPoint, stdout);
	fputs("}", filePtr);
}

/**
 * Find skyline point with respect to order R, using preference tree algorithm
 * 
 * @param aConfig Config
 * @param dimLevel Level of current recursive call
 * @param node Current node
 * @param skyline Set of global skyline point
 * @param R User preferences
 * @return Set of skyline points
 * @author Terry
 * @since 19 March 2007
 */
mySet *preferenceTree_queryDescend(config *aConfig, int dimLevel, preferenceTreeNode* node, mySet *gSkyline, mySetSet *R)
{

	int i, j;
	//list_entry *le;
	//list *a, *b, *c;
	mySet *a, *b, *c;

	//list *childS;
	//list *nA, *nB, *oA, *oB;
	mySet *childS;
	mySet *nA, *nB, *oA, *oB;

	int noOfNum	= (aConfig->noOfDim - aConfig->noOfCat) ;
	//list *S;
	mySet *S;
	int pNo;
	int val;
	int aClassBefore;
	int aSingleElt;
	//list *gSkyline_reduce;
	mySet *gSkyline_reduce;
	record *data;

	mySet *dimR;
	//list_entry *le;
//	printf("%d\n", dimLevel);
//	printf("Level: %d\n", dimLevel);
//	fflush(stdout);

	data = aConfig->data;

	if (dimLevel < aConfig->noOfCat-1)
	{
		//If current descend is not at the last dimension, gather result
		//from child node and merge them

		dimR = R->elt[dimLevel+1];

		if (dimR->noOfElt==0)
		{
			//User did not specify preference in next level/dimension.
			//Skip next dimension by jumping via "empty" child node

			//Empty node have classBefore value -1
			//gSkyline_reduce = list_minus(gSkyline, node->disqualifiedPoint);
			//S = preferenceTree_queryDescend(aConfig, dimLevel+1, node->child[0], gSkyline_reduce, R);
			//list_free(gSkyline_reduce);
			S = preferenceTree_queryDescend(aConfig, dimLevel+1, node->child[0], gSkyline, R);
		}
		else if (dimR->noOfElt==1)
		{
			pNo = dimR->elt[0];
			if (dimLevel != -1)
			{
				gSkyline_reduce = setSort_minus(gSkyline, node->setDisqualifiedPoint);
			}
			else
			{
				gSkyline_reduce = gSkyline;
			}
			S = preferenceTree_queryDescend(aConfig, dimLevel+1, node->child[pNo+1], gSkyline_reduce, R);
			if (dimLevel != -1)
			{
				//list_free(gSkyline_reduce);
			}
		}
		else
		{

			
			//get the skyline result from each selected child nodes
			for (i=0;i<dimR->noOfElt;i++)
			{
				pNo = dimR->elt[i];

				aClassBefore = node->child[pNo+1]->classBefore;

				//Go to next level
				if (dimLevel != -1)
				{
					gSkyline_reduce = setSort_minus(gSkyline, node->setDisqualifiedPoint);
				}
				else
				{
					gSkyline_reduce = gSkyline;
				}	
				childS = preferenceTree_queryDescend(aConfig, dimLevel+1, node->child[pNo+1], gSkyline_reduce, R);
				if (dimLevel != -1)
				{
					//list_free(gSkyline_reduce);
				}
				//Store the result for later merging
				if(i==0)
				{
					//oA = list_new();
					//oB = list_new();
					oA = set_new();
					oB = set_new();
					//le = childS->start;
					//while(le)
					for (j = 0; j < childS->noOfElt; j++)
					{
						//aSingleElt = le->elt;
						aSingleElt = childS->elt[j];
						val = data[aSingleElt].content[dimLevel+noOfNum+1];
						if(val == aClassBefore)
						{
							//list_addAtTail(oA, aSingleElt);
							set_insert(oA, aSingleElt);
						}
						else
						{
							//list_addAtTail(oB, aSingleElt);
							set_insert(oB, aSingleElt);
						}
						//le = le->next;
					}
				}
				else
				{
					//nA = list_new();
					//nB = list_new();
					nA = set_new();
					nB = set_new();
					//le = childS->start;
					//while(le)
					for (j = 0; j < childS->noOfElt; j++)
					{
						//aSingleElt = le->elt;
						aSingleElt = childS->elt[j];

						//*** Ray has modified this
						//val = aConfig->data[le->elt].content[dimLevel+noOfNum];
						val = data[aSingleElt].content[dimLevel+noOfNum+1];
						if(val == aClassBefore)
						{
							//list_addAtTail(nA, aSingleElt);
							set_insert(nA, aSingleElt);
						}
						else
						{
							//list_addAtTail(nB, aSingleElt);
							set_insert(nB, aSingleElt);
						}
						//le = le->next;
					}
					/*
					printf("p\n");
					printf("\n\toA"); list_print(oA, stdout);
					printf("\n\toB"); list_print(oB, stdout);
					printf("\n\tnA"); list_print(nA, stdout);
					printf("\n\tnB"); list_print(nB, stdout);
					printf("\n");
					*/
					
					//a = list_intersect(oB, nA);
					//b = list_union(oA, a);
					//c = list_intersect(oB, nB);
					a = setSort_intersect(oB, nA);
					b = setSort_union(oA, a);
					c = setSort_intersect(oB, nB);
					//list_free(oA);
					//list_free(oB);
					//list_free(nA);
					//list_free(nB);
					//list_free(a);
					//set_free(oA);
					//set_free(oB);
					//set_free(nA);
					//set_free(nB);
					//set_free(a);
					//free(oA);
					//free(oB);
					//free(nA);
					//free(nB);
					//free(a);
					oA = b;
					oB = c;
				}
				//list_free(childS);
				//set_free(childS);
				//free(childS);
			}
			//S = list_union(oA, oB);
			S = setSort_union(oA, oB);
			//list_free(oA);
			//list_free(oB);
			//set_free(oA);
			//set_free(oB);
			//free(oA);
			//free(oB);
		}
	}
	else
	{
		//at the leaf
		//S = list_minus(gSkyline, node->disqualifiedPoint);
		S = setSort_minus(gSkyline, node->setDisqualifiedPoint);

		//printf("[%d] ", node->setDisqualifiedPoint->noOfElt);
	}
	
	/*
	printf(" : ");
	list_print(S, stdout);
	*/
	return S;

}


mySet *preferenceTree_queryDescend_disqualifySense(config *aConfig, int dimLevel, preferenceTreeNode* node, mySet *gSkyline, mySetSet *R)
{

	int i, j; //, k;
	//list_entry *le;
	//list *a, *b, *c;
	//mySet *a, *b, *c;

	int *isExist;

	//int pNoPrev, aClassBeforePrev;

	//list *childS;
	//list *nA, *nB, *oA, *oB;
	mySet *childS;
	mySet *childSMinus;
	//mySet *nA, *nB, *oA, *oB;

	int noOfNum	= (aConfig->noOfDim - aConfig->noOfCat) ;
	//list *S;
	mySet *returnValue;
	mySet *returnValue_new;
	int pNo;
	int val;
	int aClassBefore;
	int aSingleElt;
	//list *gSkyline_reduce;
	mySet *gSkyline_reduce;
	record *data;

	int *isPreOrder;
	int noOfClass;

	int count;

	mySet *dimR;
	//list_entry *le;
//	printf("%d\n", dimLevel);
//	printf("Level: %d\n", dimLevel);
//	fflush(stdout);

	data = aConfig->data;

	returnValue = set_new();

	if (dimLevel < aConfig->noOfCat-1)
	{
		//If current descend is not at the last dimension, gather result
		//from child node and merge them

		dimR = R->elt[dimLevel+1];

		if (dimR->noOfElt==0)
		{
			//User did not specify preference in next level/dimension.
			//Skip next dimension by jumping via "empty" child node

			//Empty node have classBefore value -1
			//gSkyline_reduce = list_minus(gSkyline, node->disqualifiedPoint);
			//S = preferenceTree_queryDescend(aConfig, dimLevel+1, node->child[0], gSkyline_reduce, R);
			//list_free(gSkyline_reduce);
			returnValue = preferenceTree_queryDescend_disqualifySense(aConfig, dimLevel+1, node->child[0], gSkyline, R);
		}
		else if (dimR->noOfElt==1)
		{
			pNo = dimR->elt[0];
			//if (dimLevel != -1)
			//{
			//	gSkyline_reduce = setSort_minus(gSkyline, node->setDisqualifiedPoint);
			//}
			//else
			//{
			//	gSkyline_reduce = gSkyline;
			//}
			returnValue = preferenceTree_queryDescend_disqualifySense(aConfig, dimLevel+1, node->child[pNo+1], gSkyline_reduce, R);
			//if (dimLevel != -1)
			//{
			//	//list_free(gSkyline_reduce);
			//}
		}
		else
		{

			noOfClass = aConfig->noOfClass[dimLevel+1];
			isPreOrder = (int *) malloc(sizeof(int)*noOfClass);
			memset(isPreOrder, 0, sizeof(int)*noOfClass);
			
			//get the skyline result from each selected child nodes
			for (i=0;i<dimR->noOfElt;i++)
			{
				pNo = dimR->elt[i];

				aClassBefore = node->child[pNo+1]->classBefore;

				//Go to next level
				//if (dimLevel != -1)
				//{
				//	gSkyline_reduce = setSort_minus(gSkyline, node->setDisqualifiedPoint);
				//}
				//else
				//{
				//	gSkyline_reduce = gSkyline;
				//}	
				childS = preferenceTree_queryDescend_disqualifySense(aConfig, dimLevel+1, node->child[pNo+1], gSkyline_reduce, R);
				//if (dimLevel != -1)
				//{
				//	//list_free(gSkyline_reduce);
				//}


				isExist = (int *) malloc(sizeof(int)*childS->noOfElt);

				childSMinus = set_new();
				count = 0;
				childSMinus->elt = (int *) malloc(sizeof(int)*childS->noOfElt);
				for (j = 0; j < childS->noOfElt; j++)
				{
					aSingleElt = childS->elt[j];
					val = data[aSingleElt].content[dimLevel+noOfNum+1];

					isExist[j] = isPreOrder[val];

/*
					isExist = 0;
					for (k = 0; k < i; k++)
					{
						pNoPrev = dimR->elt[k];

						aClassBeforePrev = node->child[pNoPrev+1]->classBefore;

						if (val == aClassBeforePrev)
						{
							isExist = 1;
							break;
						}
					}
*/
/*
					// not exist
					if (isExist == 0)
					{
						//set_insert(childSMinus, aSingleElt);
						setSort_insertSort(returnValue, aSingleElt);
					}
*/
					if (isExist[j] == 0)
					{
						//setSort_insertSort(childSMinus, aSingleElt);
						//set_insert(childSMinus, aSingleElt);
						childSMinus->elt[count] = aSingleElt;
						count++;
					}
				}
				childSMinus->noOfElt = count;



				isPreOrder[aClassBefore] = 1;

				returnValue_new = setSort_union_bulky(returnValue, childSMinus);
				returnValue = returnValue_new;

				//set_free(returnValue);
				//free(returnValue);

				// free childSMinus
				//set_free(childSMinus);
				//free(childSMinus);

				//returnValue = returnValue_new;
			}

			if (dimLevel != -1)
			{
				// non-root
				returnValue_new = setSort_union_bulky(returnValue, node->setDisqualifiedPoint);
				returnValue = returnValue_new;
			}

			// free
			//free(isPreOrder);
		}
	}
	else
	{
		//at the leaf
		//S = list_minus(gSkyline, node->disqualifiedPoint);
		//S = setSort_minus(gSkyline, node->setDisqualifiedPoint);
		// I did not clone it since I will not free the returnValue
		returnValue = node->setDisqualifiedPoint;

		//printf("[%d] ", node->setDisqualifiedPoint->noOfElt);
	}
	
	/*
	printf(" : ");
	list_print(S, stdout);
	*/
	return returnValue;

}

/**
 * Obtain skyline points from data set with respect to user preferences
 * @param aConfig Config
 * @param mdc MDC table
 * @return Set of skyline points
 * @author Terry & Sing
 * @since 27 Feb 2007
 */
mySet* preferenceTree_skylineQuery(config *aConfig, myClassSetSetSet* mdc, FILE *debugFilePtr, FILE *timeFilePtr)
{
	preferenceTreeNode* tree;
	//mySet* skyline;
	mySet* skylineSet;
	mySet *disqualifySet;
	mySetSet* R;
	//mainOrdering* fullBinaryOrdering;
	//int id = 0;
	int i;
#ifndef WIN32
	struct rusage tree_build_start;
	struct rusage tree_build_end;
	struct rusage tree_search_end;
	float qc_tree_build_time_u;
	float qc_tree_build_time_s;
	float qc_tree_search_time_u;
	float qc_tree_search_time_s;
#endif
	//Build preference tree
	puts("Building preference tree ...");
#ifndef WIN32
	getrusage(RUSAGE_SELF,&tree_build_start);
#endif
	tree = buildPreferenceTree(aConfig, mdc);
	//printf("%d \n", tree);


	//id = 0;
	//printPreferenceTree(stdout, tree, &id);

#ifndef WIN32
	getrusage(RUSAGE_SELF,&tree_build_end);
#endif

	//Read user preferences
	puts("Reading query...");
	R = config_readPreference(aConfig);

	//fullBinaryOrdering = mainOrdering_transformPartialOrder2MainOrdering(aConfig->noOfClass, R);
//	mainOrdering_printMainOrdering(stdout, fullBinaryOrdering);

	//Find skyline points
	puts("Finding skyline...");
	for (i=0; i<aConfig->noOfFullOrderQuery; i++)
	{
		//skylineSet = preferenceTree_queryDescend(aConfig, -1, tree, tree->setDisqualifiedPoint, R);

		disqualifySet = preferenceTree_queryDescend_disqualifySense(aConfig, -1, tree, tree->setDisqualifiedPoint, R);
		skylineSet = setSort_minus(tree->setDisqualifiedPoint, disqualifySet);

		//printf("(%d) ", skylineList->size);
		//printf("Skyline (%d) :", skylineSet->noOfElt);
		//set_print(stdout, skylineSet);
		//printf("\n");
//		list_print(skylineList, stdout);


		//printf("Skyline: ");
		//list_print(skylineList, stdout);
		//printf("\n");

		//list_free(skylineList);
		set_free(skylineSet);
		free(skylineSet);
	}
#ifndef WIN32
	getrusage(RUSAGE_SELF,&tree_search_end);
#endif
//	id = 0;
//	printPreferenceTree(stdout, tree, &id);
//	printf("----------");
//	puts("Answers:");
//	set_print(stdout, skyline);
//	printf("\n");
//	fprintf(stdout, "call count : %d\n", callCount);

	fprintf(debugFilePtr, "%d\n", preferenceTree_noOfNode);
	fprintf(debugFilePtr, "%d\n",  calculateSizeOfPreferenceTree(tree));

	printf("Number of Preference tree node : %d\n", preferenceTree_noOfNode);
	printf("Total size of Preference tree in bytes: %d\n",  calculateSizeOfPreferenceTree(tree));


#ifndef WIN32
	calculateExecutionTime(&tree_build_start, &tree_build_end,
			&qc_tree_build_time_u, &qc_tree_build_time_s);
	calculateExecutionTime(&tree_build_end, &tree_search_end,
			&qc_tree_search_time_u, &qc_tree_search_time_s);
	qc_tree_search_time_u /= aConfig->noOfFullOrderQuery;
	qc_tree_search_time_s /= aConfig->noOfFullOrderQuery;

	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_tree_build_time_u,
			qc_tree_build_time_s);
	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_tree_search_time_u,
			qc_tree_search_time_s);

	printf("building time: %.10f\t%.10f\n", qc_tree_build_time_u,
			qc_tree_build_time_s);
	printf("querying time: %.10f\t%.10f\n", qc_tree_search_time_u,
			qc_tree_search_time_s);
#endif

	//return skyline;
	return NULL;
}

/**
 * To calcualate the storeage size of the Preference tree with root
 * node. Please  note that it calcualte conceptual size 
 * rather than real size. e.g. pointer variable is not included
 * @param node Pointer to root node
 * @return size of MDC tree in byte
 * @author Terry & Sing
 * @since 28 Feb 2007
 */
int calculateSizeOfPreferenceTree(preferenceTreeNode *node)
{
	int size = 0;
	int i;
	//size of refinement condition
	size += sizeof(int);
	//size of set of disqualified points
	//size += (node->disqualifiedPoint->size) * sizeof(int); 
	size += (node->setDisqualifiedPoint->noOfElt) * sizeof(int); 
	if (node->noOfChild > 0) {
		for (i = 0; i< node->noOfChild; i++) 
		{
			size += calculateSizeOfPreferenceTree(node->child[i]);
		}
	}
	return size;
}

/**
 * It separate all skyline points corresponding to a node into two sets.
 * One of the set contain all skyline points which has the same attribute
 * value as the label of the node. The remaining points are put into the
 * another set.
 * @param aConfig Source of data point attribute value
 * @param skyline The set of skyline points correspond to node
 * @param node The node the the skyline points we are going to split belongs to
 * @return Array of set of skyline point
 * @author Terry & Sing
 * @since 15 Mar 2007
 */
mySet** preferenceTree_splitSkyline(config *aConfig, mySet* skyline, preferenceTreeNode *node)
{
	int i;
	//Couple is array of size two, to store match set and mismatch set 
	mySet **couple;
	//match is set of skyline with attribute value match that of node's label
	mySet *match;
   //mismatch is set of skyline with attribute different from that of
   //node's label
	mySet *mismatch;

	couple = (mySet**)malloc(sizeof(mySet*) * 2);
	match = set_new();
	mismatch = set_new();

	for (i=0 ; i<skyline->noOfElt; i++)
	{
		int pointID = skyline->elt[i];
		int dimension = node->dimNo + (aConfig->noOfDim-aConfig->noOfCat);
		int pointVal = aConfig->data[pointID].content[dimension];
		if (pointVal == node->classBefore)
		{
			set_insert(match, pointID);
		}
		else
		{
			set_insert(mismatch, pointID);
		}
	}
	couple[0] = match;
	couple[1] = mismatch;
	return couple;
}


// corresponds to IPO single-level tree
mySet ***preference_generateStorageTable(config *aConfig, myClassSetSetSet *mdc)
{
	mySet ***returnValue;

	int i, j;

	int aPointID;
	myClassSetSet *disqConditionSet ;
	myClassSet *aDisCondition;

	// malloc
	returnValue = (mySet ***) malloc(sizeof(mySet **)*aConfig->noOfCat);
	for (i = 0; i < aConfig->noOfCat; i++)
	{
		returnValue[i] = (mySet **) malloc(sizeof(mySet *)*(aConfig->noOfClass[i]+1));
		for (j = 0; j < aConfig->noOfClass[i]+1; j++)
		{
			returnValue[i][j] = set_new();
		}
	}

	for (i = 0; i < mdc->noOfElt; i++)
	{
		aPointID = mdc->pointID[i];

		disqConditionSet = mdc->elt[i];

		for (j = 0; j < disqConditionSet->noOfElt; j++)
		{
			aDisCondition = disqConditionSet->elt[j];
		}
	}

	return returnValue;
}

// return in bytes
int preference_getStorageTableSize(mySet ***storage, config *aConfig)
{
	int returnValue;
	int i, j;

	mySet *aSet;

	returnValue = 0;

	for (i = 0; i < aConfig->noOfCat; i++)
	{
		returnValue += 4;
		for (j = 0; j < aConfig->noOfClass[i]+1; j++)
		{
			returnValue += 4;

			aSet = storage[i][j];

			returnValue += aSet->noOfElt*4;
		}
	}

	return returnValue;
}


