
#include "stack.h"

myStack *stack_new()
{
	myStack *returnValue;

	returnValue = (myStack *) malloc(sizeof(myStack));
	memset(returnValue, 0, sizeof(myStack));

	return returnValue;
}

void stack_push(myStack *aStack, STNode **no)
{
	int noOfElt;

	noOfElt = aStack->noOfElt;

	if (noOfElt == 0)
	{
		aStack->elt = (STNode **) malloc(sizeof(STNode *));
	}
	else
	{
		aStack->elt = (STNode **) realloc(aStack->elt, sizeof(STNode *)*(noOfElt+1));
	}
	aStack->elt[noOfElt] = (*no);

	aStack->noOfElt++;
}

// NULL: if there is no elt
STNode *stack_pop(myStack *aStack)
{
	STNode *returnValue;

	int noOfElt;
	STNode **oldElt;

	noOfElt = aStack->noOfElt;

	if (noOfElt == 0)
	{
		returnValue = NULL;
	}
	else
	{
		returnValue = aStack->elt[noOfElt-1];

		oldElt = aStack->elt;
		if (noOfElt == 1)
		{
			// do nothing
		}
		else
		{
			aStack->elt = (STNode **) malloc(sizeof(STNode *)*(noOfElt-1));
			memcpy(aStack->elt, oldElt, sizeof(STNode *)*(noOfElt-1));
		}

		free(oldElt);
		aStack->noOfElt--;
	}

	return returnValue;
}
